/////////////////////////////////////////////////////////////////////////////
// Name:        doc.h
// Purpose:     Document classes
// Author:      Daniel Horak
// Modified by:
// RCS-ID:      $Id: doc.h,v 1.1.1.1 2003/06/06 11:28:04 horakdan Exp $
// Copyright:   (c) Daniel Horak
// Licence:     GPL
/////////////////////////////////////////////////////////////////////////////

#ifndef __DOC_H
#define __DOC_H

#include <wx/docview.h>
#include <wx/cmdproc.h>

class DataDesignerDocument: public wxDocument
{
	DECLARE_DYNAMIC_CLASS(DataDesignerDocument)

public:
	DataDesignerDocument(void);
	~DataDesignerDocument(void);
	
	wxOutputStream& SaveObject(wxOutputStream& stream);
	wxInputStream& LoadObject(wxInputStream& stream);
};

class DataDesignerCommand: public wxCommand
{
public:
	DataDesignerCommand(const wxString& name, int cmd, DataDesignerDocument *doc);
	~DataDesignerCommand(void);

	bool Do(void);
	bool Undo(void);
	
protected:
	DataDesignerDocument	*m_doc;
	int 			m_cmd;
};

#endif // __DOC_H
