/////////////////////////////////////////////////////////////////////////////
// Name:        dbmodelrelation.h
// Purpose:     Database Objects
// Author:      Daniel Horak
// Modified by:
// RCS-ID:      $Id: dbmodelrelation.h,v 1.2 2004/01/01 13:56:19 horakdan Exp $
// Copyright:   (c) Daniel Horak
// Licence:     GPL
/////////////////////////////////////////////////////////////////////////////

#ifndef __DBMODELRELATION_H
#define __DBMODELRELATION_H

class DBRelation;

class DBModelRelation : public DBObject
{
public:
	DBModelRelation(DataDesignerProject *project, DataDesignerContainer *container);
	virtual ~DBModelRelation() { }
	
	virtual void LoadXmlNode(wxXmlNode *node);
	virtual wxXmlNode *GetXmlNode();
	
	virtual void CreateShape();
	
	DBRelation *GetRealRelation() { return m_relation; }
	void SetRealRelation(DBRelation *relation) { m_relation = relation; }
	
	wxCoord		m_xpos;
	wxCoord		m_ypos;
	
protected:
	DBRelation	*m_relation;		// pointer to the real relation
};

class DBModelRelationContainer : public DataDesignerContainer
{
public:
	DBModelRelationContainer(DataDesignerProject *project, const wxTreeItemId& id);
	
	virtual ~DBModelRelationContainer() { }
	
	virtual DBObject *CreateObject();
	virtual void	ShowList();
};

class DBModelRelationListCtrl : public DBObjectListCtrl
{
public:
	DBModelRelationListCtrl(wxWindow *parent, DataDesignerContainer *container);
	
	virtual ~DBModelRelationListCtrl();
	
	virtual void SetObject(long item, DBObject *object);
};

#endif // __DBMODELRELATION_H
