/////////////////////////////////////////////////////////////////////////////
// Name:        dbprocedure.h
// Purpose:     Database Objects
// Author:      Daniel Horak
// Modified by:
// RCS-ID:      $Id: dbprocedure.h,v 1.2 2004/01/01 13:56:19 horakdan Exp $
// Copyright:   (c) Daniel Horak
// Licence:     GPL
/////////////////////////////////////////////////////////////////////////////

#ifndef __DBPROCEDURE_H
#define __DBPROCEDURE_H

class DBProcedure : public DBObject
{
public:
	DBProcedure(DataDesignerProject *project, DataDesignerContainer *container);
	virtual ~DBProcedure() { }
	
	virtual wxDialog *Editor(bool edit);

	virtual void LoadXmlNode(wxXmlNode *node);
	virtual wxXmlNode *GetXmlNode();
	
	wxString	m_language;
	wxString	m_source;
};

class DBProcedureEditor : public DBObjectEditor
{
public:
	DBProcedureEditor(DBObject *object, bool edit);
	virtual ~DBProcedureEditor();
	virtual bool TransferDataFromWindow();
	virtual bool TransferDataToWindow();
	
private:
	wxTextCtrl	*t1;
	wxComboBox	*c2;
};

class DBProcedureContainer : public DataDesignerContainer
{
public:
	DBProcedureContainer(DataDesignerProject *project, const wxTreeItemId& id);
	
	virtual ~DBProcedureContainer() { }
	
	virtual DBObject *CreateObject();
	virtual void	ShowList();
};

class DBProcedureListCtrl : public DBObjectListCtrl
{
public:
	DBProcedureListCtrl(wxWindow *parent, DataDesignerContainer *container);
	
	virtual ~DBProcedureListCtrl();
	
	virtual void SetObject(long item, DBObject *object);
};

#endif // __DBPROCEDURE_H
