/////////////////////////////////////////////////////////////////////////////
// Name:        dbrelattr.h
// Purpose:     Database Objects
// Author:      Daniel Horak
// Modified by:
// RCS-ID:      $Id: dbrelattr.h,v 1.2 2004/01/01 13:56:19 horakdan Exp $
// Copyright:   (c) Daniel Horak
// Licence:     GPL
/////////////////////////////////////////////////////////////////////////////

#ifndef __DBRELATTR_H
#define __DBRELATTR_H

class DBRelationAttribute : public DBObject
{
public:
	DBRelationAttribute(DataDesignerProject *project, DataDesignerContainer *container);
	virtual ~DBRelationAttribute() { }

	virtual wxTreeItemId AppendItem();
	
	virtual wxDialog *Editor(bool edit);
	
	virtual void LoadXmlNode(wxXmlNode *node);
	virtual wxXmlNode *GetXmlNode();
	
	wxString	m_parent;
	wxString	m_child;
};

class DBRelationAttributeEditor : public wxDialog
{
public:
	DBRelationAttributeEditor(DBObject *object, bool edit);
	virtual ~DBRelationAttributeEditor();

	virtual bool TransferDataFromWindow();
	virtual bool TransferDataToWindow();
	virtual bool Validate();
	
	DBObject *GetObject() { return m_object; }

private:
	wxComboBox	*c1;		// parent
	wxComboBox	*c2;		// child
	DBObject        *m_object;
	wxPanel         *m_panel_general;
	wxPanel         *m_panel_button;
	wxButton        *m_button_ok;
	wxButton        *m_button_cancel;
	bool            m_edit;
};

class DBRelationAttributeContainer : public DataDesignerContainer
{
public:
	DBRelationAttributeContainer(DataDesignerProject *project, const wxTreeItemId& id);
	
	virtual ~DBRelationAttributeContainer() { }
	
	virtual DBObject *CreateObject();
	virtual void	ShowList();
};

class DBRelationAttributeListCtrl : public DBObjectListCtrl
{
public:
	DBRelationAttributeListCtrl(wxWindow *parent, DataDesignerContainer *container);
	
	virtual ~DBRelationAttributeListCtrl();
	
	virtual void AddObject(long item, DBObject *object);
	virtual void SetObject(long item, DBObject *object);
};

#endif // __DBRELATTR_H
