/////////////////////////////////////////////////////////////////////////////
// Name:        dbsequence.h
// Purpose:     Database Objects
// Author:      Daniel Horak
// Modified by:
// RCS-ID:      $Id: dbsequence.h,v 1.2 2004/01/01 13:56:19 horakdan Exp $
// Copyright:   (c) Daniel Horak
// Licence:     GPL
/////////////////////////////////////////////////////////////////////////////

#ifndef __DBSEQUENCE_H
#define __DBSEQUENCE_H

class DBSequence : public DBObject
{
public:
	DBSequence(DataDesignerProject *project, DataDesignerContainer *container);
	virtual ~DBSequence() { }
	
	virtual wxDialog *Editor(bool edit);

	virtual void LoadXmlNode(wxXmlNode *node);
	virtual wxXmlNode *GetXmlNode();
	
	wxString	m_increment;
	wxString	m_minvalue;
	wxString	m_maxvalue;
	wxString	m_start;
	wxString	m_cache;
	bool		m_cycle;
};

class DBSequenceEditor : public DBObjectEditor
{
public:
	DBSequenceEditor(DBObject *object, bool edit);
	virtual ~DBSequenceEditor();
	virtual bool TransferDataFromWindow();
	virtual bool TransferDataToWindow();

private:
	wxTextCtrl	*t1;		// increment
	wxTextCtrl	*t2;		// minval
	wxTextCtrl	*t3;		// maxval
	wxTextCtrl	*t4;		// start
	wxTextCtrl	*t5;		// cache
	wxCheckBox	*c6;		// cycle
};

class DBSequenceContainer : public DataDesignerContainer
{
public:
	DBSequenceContainer(DataDesignerProject *project, const wxTreeItemId& id);
	
	virtual ~DBSequenceContainer() { }
	
	virtual DBObject *CreateObject();
	virtual void	ShowList();
};

class DBSequenceListCtrl : public DBObjectListCtrl
{
public:
	DBSequenceListCtrl(wxWindow *parent, DataDesignerContainer *container);
	
	virtual ~DBSequenceListCtrl();
	
	virtual void SetObject(long item, DBObject *object);
};

#endif // __DBSEQUENCE_H
