/////////////////////////////////////////////////////////////////////////////
// Name:        dbsimpleattr.h
// Purpose:     Database Objects
// Author:      Daniel Horak
// Modified by:
// RCS-ID:      $Id: dbsimpleattr.h,v 1.2 2004/01/01 13:56:19 horakdan Exp $
// Copyright:   (c) Daniel Horak
// Licence:     GPL
/////////////////////////////////////////////////////////////////////////////

#ifndef __DBSIMPLEATTR_H
#define __DBSIMPLEATTR_H

class DBAttribute;
class DBEntity;

class DBSimpleAttribute : public DBObject
{
public:
	DBSimpleAttribute(DataDesignerProject *project, DataDesignerContainer *container);
	virtual ~DBSimpleAttribute() { }
	
	virtual wxDialog *Editor(bool edit);
	
	virtual void LoadXmlNode(wxXmlNode *node);
	virtual wxXmlNode *GetXmlNode();
	
	DBEntity *GetEntity();
	
	DBAttribute *GetRealAttribute() { return m_attr; }
	void SetRealAttribute(DBAttribute *attr) { m_attr = attr; }
	
protected:
	DBAttribute	*m_attr;		// pointer to a real attribute of an entity
};

class DBSimpleAttributeEditor : public wxDialog
{
public:
	DBSimpleAttributeEditor(DBObject *object, bool edit);
	virtual ~DBSimpleAttributeEditor();
	virtual bool TransferDataFromWindow();
	virtual bool TransferDataToWindow();
	
	DBObject *GetObject() { return m_object; }

private:
	DBObject	*m_object;
	wxPanel		*m_panel_general;
	wxPanel		*m_panel_button;
	wxButton	*m_button_ok;
	wxButton	*m_button_cancel;
	bool		m_edit;
	wxComboBox	*c1;		// attribute
	
	DBEntity	*m_entity;
};

class DBSimpleAttributeContainer : public DataDesignerContainer
{
public:
	DBSimpleAttributeContainer(DataDesignerProject *project, const wxTreeItemId& id);
	
	virtual ~DBSimpleAttributeContainer() { }
	
	virtual DBObject *CreateObject();
	virtual void	ShowList();
};

class DBSimpleAttributeListCtrl : public DBObjectListCtrl
{
public:
	DBSimpleAttributeListCtrl(wxWindow *parent, DataDesignerContainer *container);
	
	virtual ~DBSimpleAttributeListCtrl();
	
	virtual void SetObject(long item, DBObject *object);
};

#endif // __DBSIMPLEATTR_H
