/////////////////////////////////////////////////////////////////////////////
// Name:        dbview.h
// Purpose:     Database Objects
// Author:      Daniel Horak
// Modified by:
// RCS-ID:      $Id: dbview.h,v 1.2 2004/01/01 13:56:19 horakdan Exp $
// Copyright:   (c) Daniel Horak
// Licence:     GPL
/////////////////////////////////////////////////////////////////////////////

#ifndef __DBVIEW_H
#define __DBVIEW_H

class DBView : public DBObject
{
public:
	DBView(DataDesignerProject *project, DataDesignerContainer *container);
	virtual ~DBView() { }
	
	virtual wxDialog *Editor(bool edit);

	virtual void LoadXmlNode(wxXmlNode *node);
	virtual wxXmlNode *GetXmlNode();
};

class DBViewEditor : public DBObjectEditor
{
public:
	DBViewEditor(DBObject *object, bool edit);
	virtual ~DBViewEditor();
	virtual bool TransferDataFromWindow();
	virtual bool TransferDataToWindow();
};

class DBViewContainer : public DataDesignerContainer
{
public:
	DBViewContainer(DataDesignerProject *project, const wxTreeItemId& id);
	
	virtual ~DBViewContainer() { }
	
	virtual DBObject *CreateObject();
	virtual void	ShowList();
};

class DBViewListCtrl : public DBObjectListCtrl
{
public:
	DBViewListCtrl(wxWindow *parent, DataDesignerContainer *container);
	
	virtual ~DBViewListCtrl();
	
	virtual void SetObject(long item, DBObject *object);
};

#endif // __DBVIEW_H
