/////////////////////////////////////////////////////////////////////////////
// Name:        dbsgeneric.h
// Purpose:     Database Server - Generic
// Author:      Daniel Horak
// Modified by:
// RCS-ID:      $Id: dbsgeneric.h,v 1.2 2003/12/21 22:04:34 horakdan Exp $
// Copyright:   (c) Daniel Horak
// Licence:     GPL
/////////////////////////////////////////////////////////////////////////////

#ifndef __DBSGENERIC_H
#define __DBSGENERIC_H

class DataDesignerView;

struct DBServerGenericStyle {
	wxString m_xslt;
#ifdef HAVE_XSLT_SUPPORT
	xsltStylesheetPtr m_stylesheet;
#endif
};

class DBServerGeneric : public DBServer
{
public:
	DBServerGeneric();
	virtual ~DBServerGeneric();
	
	virtual wxString*	GetTypes()	{ return m_types; }
	virtual int		GetTypesCount()	{ return m_typescount; }
	
	virtual bool		ExportDDL(DataDesignerView *view);
	int			SelectServer();

private:
	static wxString	m_types[];
	static int	m_typescount;

	static wxString	m_servers[];
	static int	m_serverscount;

	static DBServerGenericStyle	m_styles[];
};

#endif // __DBSGENERIC_H
