/////////////////////////////////////////////////////////////////////////////
// Name:        dbspgsql.cpp
// Purpose:     Database Server - PostgreSQL
// Author:      Daniel Horak
// Modified by:
// RCS-ID:      $Id: dbspgsql.cc,v 1.1.1.1 2003/06/06 11:28:05 horakdan Exp $
// Copyright:   (c) Daniel Horak
// Licence:     GPL
/////////////////////////////////////////////////////////////////////////////

// ============================================================================
// declarations
// ============================================================================

// ----------------------------------------------------------------------------
// headers
// ----------------------------------------------------------------------------

// For compilers that support precompilation, includes "wx/wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

// for all others, include the necessary headers (this file is usually all you
// need because it includes almost all "standard" wxWindows headers
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include "xml.h"
#include "dbserver.h"
#include "dbspgsql.h"

wxString DBServerPostgreSQL::m_types[] = {
    "bool",
    "bytea",
    "char",
    "date",
    "float4",
    "float8",
    "int2",
    "int4",
    "int8",
    "numeric",
    "text",
    "time",
    "timestamp",
    "varchar"
};

int DBServerPostgreSQL::m_typescount = sizeof(DBServerPostgreSQL::m_types) / sizeof(wxString);

wxString DBServerPostgreSQL::m_langs[] = {
    "C",
    "plperl",
    "plpgsql",
    "plpython",
    "pltcl",
    "SQL"
};

int DBServerPostgreSQL::m_langscount = sizeof(DBServerPostgreSQL::m_langs) / sizeof(wxString);

DBServerPostgreSQL::DBServerPostgreSQL()
	: DBServer(DBServerTypePostgreSQL, "PostgreSQL", "7.3", "pgsql.xsl")
{
}

DBServerPostgreSQL::~DBServerPostgreSQL()
{
}
