/////////////////////////////////////////////////////////////////////////////
// Name:        view.h
// Purpose:     View classes
// Author:      Julian Smart
// Modified by:
// RCS-ID:      $Id: view.h,v 1.1.1.1 2003/06/06 11:28:04 horakdan Exp $
// Copyright:   (c) Daniel Horak
// Licence:     GPL
/////////////////////////////////////////////////////////////////////////////

#ifndef __VIEW_H
#define __VIEW_H

#include <wx/docview.h>
#include <wx/splitter.h>

class DataDesignerProject;

class DataDesignerSplitter: public wxSplitterWindow
{
public:
	DataDesignerSplitter(wxView *v, wxMDIChildFrame *frame, const wxPoint& pos, const wxSize& size, long style);

	virtual void OnDraw(wxDC& dc);
	
	DataDesignerProject	*GetProject() { return m_project; }
	wxView			*GetView() { return m_view; }

	wxView			*m_view;
	wxPanel			*m_panel;
	
private:
	DECLARE_EVENT_TABLE()

protected:
	DataDesignerProject	*m_project;
};

class DataDesignerView: public wxView
{
public:
	DataDesignerView();
	~DataDesignerView();

	bool OnCreate(wxDocument *doc, long flags);
	void OnDraw(wxDC *dc);
	void OnUpdate(wxView *sender, wxObject *hint = (wxObject *) NULL);
	bool OnClose(bool deleteWindow = TRUE);
	
	void OnObject(wxCommandEvent& event);
	void OnZoom(wxCommandEvent& event);
	void OnExportDDL(wxCommandEvent& event);

	wxMDIChildFrame		*m_frame;
	DataDesignerSplitter	*m_splitter;
	
	int GetZoom() { return m_zoom; }

private:
	DECLARE_DYNAMIC_CLASS(DataDesignerView)
	DECLARE_EVENT_TABLE()

protected:
	int	m_zoom;
};

#endif // __VIEW_H
